/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date  $
 * $RCSfile: drv_hdmi.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
#ifndef _DRV_EDID_H_
#define _DRV_EDID_H_

#define HDMI_EDID_MUX_SEL
//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------
#define HDMIEDID_DATA_BLOCK_START_INDEX 4
#define HDMIEDID_AUDIO_DATA_BLOCK_TAG_CODE 1
#define HDMIEDID_AUDIO_DATA_BLOCK_SIZE 3
#define HDMIEDID_AUDIO_EAC3_FMT_TYPE 0xA
#define HDMIEDID_AUDIO_ATMOS_BIT_MASK 0x1
#define HDMIEDID_CHECKSUM_INDEX 127
#define HDMIEDID_INVALID_DATA_INDEX 127

#define HDMIEDID_DATA_BLOCK_TAG_CODE_MASK_VALUE(_a_) (((_a_)&0xE0)>>5)
#define HDMIEDID_DATA_BLOCK_LENGTH_MASK_VALUE(_a_) ((_a_)&0x1F)
#define HDMIEDID_AUDIO_FMT_TYPE_MASK_VALUE(_a_) (((_a_)&0x78)>>3)
#define HDMIEDID_AUDIO_ATMOS_BIT_MASK_VALUE(_a_) ((_a_)&0x1)

typedef enum
{
    HDMI2_EDID_TYPE_STANDARD,
    HDMI2_EDID_TYPE_ENHANCE,
} HDMI2_EDID_TYPE_T;

typedef enum {
    HDMI_EDID20_TYPE_STANDARD,//no HF_VSDB
    HDMI_EDID20_TYPE_ENHANCE,//has HF_VSDB
    MHL_EDID
}HDMI_EDID_CHECK_MODE_T;

extern UINT8 u1HDMIEDIDGetAtmosEnable(void);
extern void vHDMIEDIDSetAtmosEnable(UINT8 u1Enable);
extern UINT8 u1HDMIEDIDCalCheckSum(UINT8 *pu1EdidBlockx);
extern void vHDMIEDIDReplaceAtmosBit(UINT8 *pu1EdidBlock1,UINT8 u1AtmosEnable);
extern void vHDMI14WriteEDIDToSram(UINT8 *pu1Edid);
#ifdef CC_HDMI_2_0_SUPPORT
extern void vHDMI20WriteEDIDToSram(UINT8 *pu1Edid);
extern void vHDMI20LoadEDID14(void);
extern void vHDMI20LoadEDID20(void);
extern void vHDMI20Write3G420EDIDToSram(UINT8 *pu1Edid);

extern void vHDMI20EDIDMuxSel(void);
extern void vHDMI20LoadEDID3G420(void);
extern void  vHDMI20EDIDDisable3G420(BOOL fgDisable);
#endif
extern void vMHLWriteEDIDToSram(UINT8 *pu1Edid);
extern void vHDMI14EDIDDisable(BOOL fgDisable);
extern void vHDMI20EDIDDisable(BOOL fgDisable);
#if defined(CC_S_PLATFORM) && defined(CC_PHX_CUST)
extern void vHDMI20WriteEDIDToSramForSony(UINT8 ePort,UINT8 *pu1Edid);
extern void vHDMI20EDIDMuxSelForSony(void);
extern void vHDMI20LoadEDID(UINT8 ePort);
extern void vHDMI_INTERNAL_EDID_Init_Sony(void);
#else      
extern void vHDMI_INTERNAL_EDID_Init(void);        
#endif
extern void vMHL_INTERNAL_EDID_Init(void);
extern void vMHL20LoadEDID20(void);
#ifndef CC_MTK_LOADER
extern UINT8 * bMHLGetEDIDTable(void);
extern UINT8 u1HDMIEDIDCheckValid(HDMI_EDID_CHECK_MODE_T eEdidMode);
extern BOOL fgHDMIEDIDHandleSAD(BOOL fgSet,UINT8 u1FormatNum,UINT8 *pu1AudioDataBlock);
#endif
#endif

