/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*----------------------------------------------------------------------------*/
/*! @file c_hbbtv.h 
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/11/26 $
 *  $Author: dtvbm11 $
 *  
 *  @par Description: This header file declares HBBTV exported APIs.
 */
/*----------------------------------------------------------------------------*/
#ifndef _U_OPERA_HBBTV_SI_LOADER_H_
#define _U_OPERA_HBBTV_SI_LOADER_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "u_common.h"
#include "u_handle.h"
#include "u_opera_hbbtv.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/

#define OPHT_SI_LOADER            (HT_GROUP_OP_HBBTV + (HANDLE_TYPE_T) 0)

typedef UINT16 OPERA_HBBTV_SIL_NFY_COND_T;

#define OPERA_HBBTV_SIL_COND_LOAD_START      ((OPERA_HBBTV_SIL_NFY_COND_T)  0)
#define OPERA_HBBTV_SIL_COND_LOAD_RUNNING    ((OPERA_HBBTV_SIL_NFY_COND_T)  1)
#define OPERA_HBBTV_SIL_COND_LOAD_FAILED     ((OPERA_HBBTV_SIL_NFY_COND_T)  2)

typedef UINT16 OPERA_HBBTV_SIL_NFY_DATA_T;

#define OPERA_HBBTV_SIL_PAT_UPDATE      ((OPERA_HBBTV_SIL_NFY_DATA_T)  1)
#define OPERA_HBBTV_SIL_PAT_UNAVAIL     ((OPERA_HBBTV_SIL_NFY_DATA_T)  2)
#define OPERA_HBBTV_SIL_PAT_TIMEOUT     ((OPERA_HBBTV_SIL_NFY_DATA_T)  3)
#define OPERA_HBBTV_SIL_PAT_LOAD_FAIL   ((OPERA_HBBTV_SIL_NFY_DATA_T)  4)
#define OPERA_HBBTV_SIL_PMT_UPDATE      ((OPERA_HBBTV_SIL_NFY_DATA_T)  5) /*PMT available*/
#define OPERA_HBBTV_SIL_PMT_UNAVAIL     ((OPERA_HBBTV_SIL_NFY_DATA_T)  6)
#define OPERA_HBBTV_SIL_PMT_TIMEOUT     ((OPERA_HBBTV_SIL_NFY_DATA_T)  7)
#define OPERA_HBBTV_SIL_PMT_LOAD_FAIL   ((OPERA_HBBTV_SIL_NFY_DATA_T)  8)
#define OPERA_HBBTV_SIL_AIT_UPDATE      ((OPERA_HBBTV_SIL_NFY_DATA_T)  9) /*App available, to enable HbbTV engine*/
#define OPERA_HBBTV_SIL_AIT_CHANGED     ((OPERA_HBBTV_SIL_NFY_DATA_T)  10)
#define OPERA_HBBTV_SIL_AIT_UNAVAIL     ((OPERA_HBBTV_SIL_NFY_DATA_T)  11)
#define OPERA_HBBTV_SIL_AIT_TIMEOUT     ((OPERA_HBBTV_SIL_NFY_DATA_T)  12)
#define OPERA_HBBTV_SIL_AIT_LOAD_FAIL   ((OPERA_HBBTV_SIL_NFY_DATA_T)  13)
#define OPERA_HBBTV_SIL_ROOT_TIMEOUT    ((OPERA_HBBTV_SIL_NFY_DATA_T)  14)
#define OPERA_HBBTV_SIL_UNLOADED        ((OPERA_HBBTV_SIL_NFY_DATA_T)  15)
#define OPERA_HBBTV_SIL_NOT_ALLOWED     ((OPERA_HBBTV_SIL_NFY_DATA_T)  16)

typedef enum{
    OPERA_HBBTV_SIL_GET_UNKNOWN,
    OPERA_HBBTV_SIL_GET_AIT_LENGTH,
    OPERA_HBBTV_SIL_GET_AIT_SECTION,
    OPERA_HBBTV_SIL_GET_PMT_LENGTH,
    OPERA_HBBTV_SIL_GET_PMT_SECTION,    
    OPERA_HBBTV_SIL_GET_BRDCST_MEDIUM
}OPERA_HBBTV_SIL_GET_TYPE;

typedef VOID (*x_opera_hbbtv_sil_nfy_fct)(
                    OPERA_HBBTV_SIL_NFY_COND_T  e_nfy_cond,
                    VOID*                       pv_data,
                    VOID*                       pv_nfy_tag);


#endif



